<?php
/*
Plugin Name: Facebook Album Post
Plugin URI: http://www.luchendo.com/
Description: Facebook Album Post allows you to instantly create a Post with a Photo Gallery, a title and a Featured Image from any public Facebook Album. It has never been easier to create a Post on your blog from a Facebook Album. It requires the Facebook Page Photo Gallery Plugin to Work. 
Author: Chen-Do Lu
Version: 1.2
Author URI: http://www.luchendo.com
*/
ob_start();


/* PLUGIN SETTINGS */
define('FBAP_PLUGIN_NAME', 'FB Album Post') ; 

/* PLUGIN PARAMETERS */
$FBACCESSTOKEN = get_option('fbap_fbAccessToken');
define('FB_URL', 'https://graph.facebook.com/') ; 
define('FB_ACCESS_TOKEN', $FBACCESSTOKEN ) ;  

//----------------------


class facebookAlbumPost
{
    function facebookAlbumPost(){            
		try{
			add_action('admin_menu', array(&$this,'ext_add_pages'));
			add_action( 'wp_ajax_properAddItemAjax', 'properAddItemAjax' );
			add_action( 'wp_ajax_getUserPublicAlbumsAjax', 'getUserPublicAlbumsAjax' );
			add_action( 'wp_ajax_getAlbumAjax', 'getAlbumAjax' );

		}
		catch(Exception $e){
			echo "Caught Exception".$e->getMessage();
		}
   }
    // action function for above hook
    function ext_add_pages(){
		add_menu_page(FBAP_PLUGIN_NAME, __(FBAP_PLUGIN_NAME,'fbap_menu'), 'manage_options', 'facebook-album-post', array ( & $this,'uploadImage'));
		add_submenu_page('facebook-album-post', 'Settings ','Settings', 'manage_options', 'facebook-album-post-options',array ( & $this,'fbapSettings'));
	}
	
	//Main Plugin Page
	function uploadImage(){ 
		$pageContent = 'facebook-album-post.php' ; 
		include_once($pageContent);
	}
	
	//Plugin Setting Page
	function fbapSettings(){
		include_once('facebook-album-post-options.php');
	}
	
	
	function get_all_post()
	{
				
		$options_pages = array();
		$options_pages_obj = get_posts('post_type=post');
		$options_pages[''] = 'Select a Post:';
		foreach ($options_pages_obj as $page) {
		$options_pages[$page->ID] = $page->post_title;
		}
		return $options_pages;
	}	
	
 }
$newObj = new facebookAlbumPost();


//--------------load scripts
function fap_plugin_scripts() {
	 $css= plugins_url().'/facebook-album-post/style.css';
     wp_register_style( 'custom_wp_admin_css2', $css, false, '1.0.0' );
     wp_enqueue_style( 'custom_wp_admin_css2' );
}

//Limit CSS to plugin's pages
if (isset($_GET['page']) && ($_GET['page'] == 'facebook-album-post')) 
{ 
	add_action('admin_init', 'fap_plugin_scripts');
}


//------------- Ajax Add Item to Posts
function properAddItemAjax(){
		check_ajax_referer( 'fbap_nonce', 'security' );
		$content="" ; 
		$title = $_POST['title'];

		// GET Facebook Album ID
		$facebook_album_id = $_POST['facebook_album_id']; 
		
		//CREATE A POST 
			//SET the ShortCode in Content
			$content.="[fbphotos id=$facebook_album_id]" ; 
			
			//Save Post in Draft mode
			   	$post = array();
				$post['post_author'] = $user_id ;
				$post['post_status'] = 'draft';
				//$post['post_category'] = $post_categories;
				$post['post_title'] = $title ; 
				$post['post_content'] = $content  ; 
				$post['comment_status'] = 'open';
				
				$post_id = wp_insert_post($post);
		
		
		//DOWNLOAD AND SET FEATURED IMAGE 
		$image_url 	= trim($_POST['imageUrl']); 
		if(!empty($post_id) && !empty($image_url))
		{
			// load the image
			$result = media_sideload_image($image_url, $post_id, $title.' [FB Album Post]');
			if(!$result->errors['upload_error']){
				if(has_post_thumbnail($post_id)){
							delete_post_thumbnail($post_id);
				 }
				
				$attachments = get_posts(array('post_parent' => $post_id, 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => 'DESC'));
				
				if(sizeof($attachments) > 0){
					// set image as the post thumbnail
					set_post_thumbnail($post_id, $attachments[0]->ID);
				} 
				
				$status = '<span style="color:green">Your image has been set as Feature Image <a href="'.(admin_url('post.php?post='.$post_id.'&action=edit')).'" target="_blank"/>Click here to view </a></span>';	
			}else{
				$status = "<span style='color:red'>This is not a valid image url </span>" ;
			}
		}else{
				$status = "<span style='color:red'> Please select post AND insert image url </span>" ;
			}	
		die() ; 
		
	}//end add item

	
///----------------------------------------------------------------------------------------------------	
//------------- Ajax List useralbums
function getUserPublicAlbumsAjax(){
	check_ajax_referer( 'fbap_nonce', 'security' );

	//Get all images from the specified album
	$FBUsername=$_POST['username']; 
	
	if(isset($FBUsername) && !empty($FBUsername)){
		$JSON = fbap_getUserPublicAlbums($FBUsername) ; 
		header('Content-Type: application/json');
		echo $JSON ; 
	}
	else {
		echo 'ERROR' ; 
		}	
	die();
}

//Request Album JSON Description from OpenGraph
function fbap_getUserPublicAlbums($FBUsername, $options = array()) {

        $url= FB_URL.$FBUsername. "/albums?fields=name,id&access_token=".FB_ACCESS_TOKEN ; 
        $response = remoteGet_fap($url);
        return $response ;
}

//------------- End Ajax List useralbums ----------------------------------------------------------------------------------------------------	



///----------------------------------------------------------------------------------------------------	
//------------- Ajax Get Album images
function getAlbumAjax(){
	check_ajax_referer( 'fbap_nonce', 'security' );
	//Get all images from the specified album
	$facebook_album_id=urldecode($_POST['facebook_album_id']); 

	if(isset($facebook_album_id) && !empty($facebook_album_id)){	
	$JSON = getAlbum_fap($facebook_album_id) ; 
	header('Content-Type: application/json');
	echo $JSON ; 
	}
	else {
		echo 'ERROR' ; 
		}
	die() ; 

}

//Request Album JSON Description from OpenGraph
function getAlbum_fap($albumId, $options = array()) {
        $limit = isset($options['limit']) ? $options['limit'] : 40;
        $url= FB_URL.$albumId . "?fields=name,photos.limit($limit)&access_token=".FB_ACCESS_TOKEN ; 
        $response = remoteGet_fap($url);
        return $response ;
    }
//------------- End Ajax Get Album images ----------------------------------------------------------------------------------------------------	


//Get content from a remote URL
function remoteGet_fap($url,$options=array()) {
    add_filter('http_request_timeout','fbap_moreTime');
    $raw_response = wp_remote_get($url,$options);
    if ( is_wp_error( $raw_response ) || 200 != wp_remote_retrieve_response_code( $raw_response ) )
            return false;
	
    $response = wp_remote_retrieve_body( $raw_response );

    return $response;
}
function fbap_moreTime(){
    return 60;
}
?>
